#include <bits/stdc++.h>
using namespace std;
#define ll long long
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n,k;
    cin>>n>>k;
    vector<ll>v(n+1);
    for(int i=1;i<=n;i++)
    {
        cin>>v[i];
    }
    ll s=0,l=0;
    for(int i=1;i<=n;i++)
    {
        if(v[i]==1)
        {
            s++;
        }
        else if(v[i]==2)
        {
            l++;
        }
    }
    if(k>s && k>l)
    {
        cout<<0;
        return 0;
    }
    else if(k<=s && k>l)
    {
        cout<<1;
        return 0;
    }
    else if(k>s && k<=l)
    {
        cout<<2;
        return 0;
    }
    ll d=0,m=0;
    for(int i=1;i<=n;i++)
    {
        if(v[i]==2)
        {
            if(m)
                d++;
            m=0;
        }
        else if(v[i]==1)
        {
            m++;
        }
    }
    ll z=0,f=0;
    for(int i=1;i<=n;i++)
    {
        if(v[i]==1)
        {
            if(z)
                f++;
            z=0;
        }
        else if(v[i]==2)
        {
            z++;
        }
    }
    if(k<=max(f,d))
    {
        cout<<3;
    }
    else
    {
        cout<<2;
    }
}
